<?php

namespace HCM\FPA\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;

class ParametroFolhaRepository {

    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection    = $connection;
        $this->entityManager = $entityManager;
    }
   
    public function ParametroFolhaRepository($nrgrpincide){

       $query = <<<SQL
select count(*) from fpa_grpitem where NRGRPINCIDE = :P_NRGRPINCIDE and NREVENTOM is null
SQL;
		$params = array(
		    'P_NRGRPINCIDE'=> $nrgrpincide
		    );
        return $this->connection->fetchAll($query,$params);
    }
}