<?php
namespace HCM\PTO\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;

class HorarioRepository {

    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection    = $connection;
        $this->entityManager = $entityManager;
    }

    /**
     * @return array
     */
    public function removeSaidaHorario($dataset) {
        $query = $this->entityManager->getConnection()->prepare("
               UPDATE GPE_INTERVALOSHORARIO
                  SET HRPROJETARINTERVALO = null, DSINTERVALOPROJETADO = null
                WHERE NRORG              = :NRORG
                  AND NRHORDIAM          = :NRHORDIAM
                  AND NRINTERVALOHORARIO = :NRINTERVALOHORARIO
                  AND NRSEQINTERVHORARIO = :NRSEQINTERVHORARIO");

        $return = $query->execute(
            array(
                "NRORG"               => $dataset["NRORG"],
                "NRHORDIAM"           => $dataset["NRHORDIAM"],
                "NRSEQINTERVHORARIO"  => $dataset["NRSEQINTERVHORARIO"],
                "NRINTERVALOHORARIO"  => $dataset["NRINTERVALOHORARIO"]
            )
        );
        return $return;
    }

} 

